<?
define("invoicePatt","../system/patterns/orderpatt/invoice_pattern.htm");
define("clientMailPatt","../system/patterns/orderpatt/client_mail_pattern.txt");
define("companyMailPatt","../system/patterns/orderpatt/company_mail_pattern.txt");
define("errorMailPatt","../system/patterns/orderpatt/error_mail_pattern.txt");
$id=$_GET[1];
$obj=$_GET[2];
if($obj){
	include('_settings.php');
	include('_params.php');
	include('_utils.php');
	_specProc($obj,1,$id);
}
function _specProc($obj,$mode=0,$usrId=0){
	global $mstData;
	global $cMstId;
	global $gMoneyFormat;
	if(!$mode){
		$main=_getRootObj('main');
		if(!$main){
			return array($err='  !      [Error: ord000]',1);
		}
		$uord=_getRootObj('uord');
		if(!$uord){
			$err='  !      [Error: ord001]';
		}
		if(!_openObj($obj[0][0],-1)){
			$err='  !   ! [Error: ord003]';
		}
		if($err){
			if(_openObj($main)){
				$sender=_getSysAttr($mstData[$cMstId][$main],'co_email');
				_sentMailPatt($sender,$sender,errorMailPatt,array('{invdate}'=>_formatVal(getdate(),'t'),'{err}'=>$err));
			}
			return array($err,1);
		}
		$ord=&$mstData[$cMstId][$obj[0][0]];
		$usrId=uniqid('ord');
		_setSysAttr($ord,'orduid','Order identifer',$usrId);
		$docPatt=file_get_contents(invoicePatt);
		$year=_substr($docPatt,'[currentYear=',']');
		$currNum=_substr($docPatt,'[currentDocNumber=',']');
		$reset=_substr($docPatt,'[newYearDocNumber=',']');
		$pref=_substr($docPatt,'[docNumberPref=',']');
		$post=_substr($docPatt,'[docNumberYearPost=',']');
		$currYear=date('Y');
		if($year!=$currYear&&$reset!=''){
			$num=$reset;
		}else{
			$num=$currNum+1;
		}
		if($post){
			$post='-'.substr($currYear,2);
		}
		_setSysAttr($ord,'number','Number',$pref.$num.$post);
		$curren=_getCurrency();
		$total=0;
		if($ord[3]['pston']){
			foreach($ord[3]['pston'] as $pos){
				if(_openObj($pos[7],-1)){
					$posobj=&$mstData[$cMstId][$pos[7]];
					$qty=_getSysAttr($posobj,'qty');
					$cost=_getSysAttr($posobj,'cost');
					if($curren[1]!=1){
						$cost=$cost*$curren[1];
						_setSysAttr($posobj,'cost','',$cost,'',1);
					}
					$disc=_getSysAttr($posobj,'dscval');
					$discType=_getSysAttr($posobj,'dsctp');
					if($qty&&$cost){
						if(!$disc){
							$disc=0;
						}
						if($discType=='%'){
							$total+=_nCut($qty*$cost*(1-$disc*0.01),2);
						}else{
							$total+=$qty*$cost-$disc;
						}
					}
				}
			}
		}
		$totDisc=_getSysAttr($ord,'odscvl');
		if($totDisc){
			$totDisc=(_getSysAttr($ord,'odsctp')=='%')?(_nCut($total*$totDisc*0.01,2)):($totDisc);
			$total-=$totDisc;
		}
		_openObj($obj[0][0],-1);
		$ord=&$mstData[$cMstId][$obj[0][0]];
		_setSysAttr($ord,'total','Total',$total);
		if($year!=$currYear){
			$docPatt=str_replace('[currentYear='.$year.']','[currentYear='.$currYear.']',$docPatt);
		}
		$docPatt=str_replace('[currentDocNumber='.$currNum.']','[currentDocNumber='.$num.']',$docPatt);
		_fwrite(invoicePatt,$docPatt);
		$res='order0.php'.'?1='.$usrId.'&2='.$obj[0][0];
		$ordDate=_getSysAttr($ord,'date');
		$delivReg=_getSysAttr($ord,'dlvrg');
		$delivTot=_getSysAttr($ord,'dlvtt');
		if($curren[1]!=1){
			$delivTot=$delivTot*$curren[1];
			_setSysAttr($ord,'dlvtt','',$delivTot,'',1);
		}
		$prop='ordnum'.'!2='.$pref.$num.$post.'!1='.
				'ordtt'.'!2='.$total.'!1='.
				'ordttdsc'.'!2='.$totDisc.'!1='.
				'orddate'.'!2='._formatVal($ordDate,'t').'!1='.
				'ordtime'.'!2='.$ordDate.'!1='.
				'delivrg'.'!2='.($delivReg?$delivReg:'').'!1='.
				'delivtt'.'!2='.($delivReg?$delivTot:'');
		foreach($ord[2] as $grp){
			if($grp[0]=='info'){
				foreach($grp[3] as $attr){
					$attr=$ord[3][$attr[0]][$attr[1]];
					$prop.='!1='.($attr[0]=='clprp'?$attr[2]:$attr[0]).'!2='.$attr[3];
					$clprop[$attr[0]]=$attr[3];
				}
			}
		}
		if(_openObj($uord)){
			$uordobj=$mstData[$cMstId][$uord];
			$invMode=_getSysAttr($uordobj,'inv_on');
			$compMode=_getSysAttr($uordobj,'co_snd');
			$clientMode=_getSysAttr($uordobj,'cl_snd');
			if($invMode&&($compMode||$clientMode)&&_openObj($main)){
				$mainobj=$mstData[$cMstId][$main];
				$sender=_getSysAttr($mainobj,'co_email');
				if($sender){
					$to=$clprop['clml'];
					$phref='http://'.$_SERVER['HTTP_HOST'].$_SERVER['SCRIPT_NAME'];
					$href=str_replace('_request.php',$res,$phref);
					$repl=array(
						'{invoice}'=>$href
						,'{invdate}'=>_formatVal($ordDate,'t')
						,'{invtotal}'=>_formatVal($total,'m')
						,'{invnum}'=>$pref.$num.$post
						,'{phone}'=>_getSysAttr($mainobj,'co_phone')
						,'{email}'=>$sender
						,'{web}'=>str_replace('php/_request.php','',$phref)
						,'{client}'=>$clprop['clnm']
						,'{clphone}'=>$clprop['clph']
						,'{clmail}'=>$to
						,'{cladr}'=>$clprop['cladr']
						,'{sitename}'=>_getSysAttr($mainobj,'siteNm')
					);
					if($clientMode&&$to){
						_sentMailPatt($sender,$to,clientMailPatt,$repl);
					}
					if($compMode){
						_sentMailPatt($sender,$sender,companyMailPatt,$repl);
					}
				}
			}
		}
		return array($res.'!0='.$prop,0);
	}else{
		print '<meta http-equiv="content-type" content="text/html; charset=windows-1251">';
		if(!_openObj($obj)){print '    ! Error order object [Error: ord002]';return;}
		$obj=$mstData[$cMstId][$obj];
		$uid=_getSysAttr($obj,'orduid');
		if($uid!=$usrId){
			alert('Access deny');
			return;
		}
		$uord=_getRootObj('uord');
		if(!$uord||!_openObj($uord)){print '    ! Error system object of requisites [Error: ord001])';return;}
		$uord=$mstData[$cMstId][$uord];
		$curren=_getCurrency();
		$docPatt=file_get_contents(invoicePatt);
		$patt=_substr($docPatt,'<document>','</document>');
		$num=_getSysAttr($obj,'number');
		$repl['{num}']=$num;
		$date=_getSysAttr($obj,'date');
		$currHTML=_formatVal($date,'d');
		$repl['{date}']=$currHTML?$currHTML:'';
		$currHTML=_formatVal($date,'t');
		$repl['{time}']=$currHTML?$currHTML:'';
		$currHTML=_getSysAttr($uord,'rqseal');
		$repl['{seal}']=$currHTML?'<img src="'.picDir.$currHTML.'">':'';
		$currHTML='';
		foreach($uord[2] as $group){
			if($group[0]=='ereq'&&$group[1]=='cog'){
				$currHTML='<table width="100%"; CELLSPACING=0 class="tab">';
				foreach($group[3] as $attr){
					if($attr[0]=='rqseal'){continue;}
					$val=$uord[3][$attr[0]][$attr[1]];
					if($attr[0]=='rqcnm'){
						$repl['{comp_name}']=$val[3];
						continue;
					}
					if($attr[0]=='rqadd'){
						if($val[3]){
							$addInfo='<b>'.($val[2]===''?'&nbsp;':$val[2]).'</b><br />'.$val[3];
						}
						continue;
					}
					$currHTML.='<TR><TD width="30%" class="tabCel">'.($val[2]===''?'&nbsp;':$val[2]).'<TD WIDTH=70% class="tabCel">'.($val[3]===''?'&nbsp;':$val[3]);
				}
				$currHTML.='</table>';
				break;
			}
		}
		$repl['{comp_prop}']=$currHTML;
		$currHTML='';
		foreach($obj[2] as $group){
			if($group[0]=='info'){
				$currHTML='<table width="100%"; cellspacing="0" class="tab">';
				foreach($group[3] as $attr){
					$val=$obj[3][$attr[0]][$attr[1]];
					if($attr[0]=='clnm'){
						$repl['{client_name}']=$val[3];
						continue;
					}
					$currHTML.='<TR><TD WIDTH=30% class="tabCel">'.(($val[2]==='')?('&nbsp;'):($val[2])).'<TD WIDTH=70% class="tabCel">'.(($val[3]==='')?('&nbsp;'):($val[3]));
				}
				$currHTML.='</table>';
			}
		}
		$repl['{client_prop}']=$currHTML;
		$currNum=0;
		$total=0;
		$totTax=0;
		$currHTML='';
		$discMode=0;
		$codeMode=0;
		$totDisc=_getSysAttr($obj,'odscvl');
		$totTaxMode=_getSysAttr($uord,'tax_on');
		$taxName=_getSysAttr($uord,'tax_name');
		if($obj[3]['pston']){
			foreach($obj[3]['pston'] as $pos){
				if(_openObj($pos[7])){
					$posobj=$mstData[$cMstId][$pos[7]];
					$qty=_getSysAttr($posobj,'qty');
					$cost=_getSysAttr($posobj,'cost');
					$disc=_getSysAttr($posobj,'dscval');
					$dType=_getSysAttr($posobj,'dsctp');
					$unit=_getSysAttr($posobj,'unit');
					$tax=_getSysAttr($posobj,'tax');
					$code=_getSysAttr($posobj,'pcode');
					if($qty&&$cost){
						if($disc){
							$discMode=1;
						}
						if($code){
							$codeMode=1;
						}
						$arr[]=array(_getSysAttr($posobj,'sNm'),$qty,$cost,$disc?$disc:0,$dType,$tax,$unit,$code);
						$nameArr[]=$name;
						$taxProp[$tax]=1;
						$currTax=$tax;
					}
				}
			}
			if($arr){
				sort($arr);
				$delivReg=_getSysAttr($obj,'dlvrg');
				if($delivReg){
					$delivTot=_getSysAttr($obj,'dlvtt');
					$delivTax=_getSysAttr($uord,'dlv_tax');
					if($delivTot>0&&$delivTax){
						$taxProp[$delivTax]=1;
					}
					$arr[]=array('<br><font class="regName"> : '.$delivReg.'</font>',1,$delivTot,'','',$delivTot>0?$delivTax:'','');
				}
				if(count($taxProp)>1){
					$posTaxMode=1;
				}
				foreach($arr as $val){
					$posTot=($val[3])?(($val[4]=='%')?(_nCut($val[1]*$val[2]*(1-$val[3]*0.01),2)):($val[1]*$val[2]-$val[3])):($val[1]*$val[2]);
					$total+=$posTot;
					$currHTML.='<tr><td class="posNum">'.(++$currNum).'</td>'.
									($codeMode?'<td class="posProp"><nobr>'.(!$val[7]?'&nbsp;':$val[7]).'</nobr>'.'</td>':'').
									'<td class="posName">'.($val[0]===''?'&nbsp;':$val[0]).'</td>'.
									'<td class="posProp">'.($val[6]===''?'&nbsp;':$val[6]).'</td>'.
									'<td class="posProp">'.($val[1]===''?'&nbsp;':$val[1]).'</td>'.
									'<td class="posProp"><nobr>'._formatVal($val[2],'nm').'</nobr>'.'</td>'.
									(($posTaxMode)?('<td class="posProp"><nobr>'.(!$val[5]?0:_nCut($val[5],2)).'</nobr>'.'</td>'):('')).
									($discMode?'<td class="posProp"><nobr>'._formatVal($val[1]*$val[2],'nm').'</nobr>'.'</td>':'').
									(($discMode)?('<td class="posProp"><nobr>'.((!$val[3])?(0):($val[4]=='%'?_formatVal($val[1]*$val[2]*$val[3]*0.01,'nm').' ('.$val[3].'%'.')':_formatVal($val[3],'nm'))).'</nobr>'.'</td>'):('')).
									'<td class="posProp"><nobr>'._formatVal($posTot,'nm').'</nobr>'.'</td></tr>';
					if($posTaxMode){
						$totTax+=$posTot*($totDisc?1-$totDisc*0.01:1)*$val[5]/(100+$val[5]);
					}
				}
			}
		}
		_rsubstr($patt,'{code}','',$codeMode);
		$repl['{pos}']=$currHTML;
		$repl['{totSum}']=_formatVal($total,'nm');
		$repl['{tax_name}']=$taxName;
		$repl['{tax_rate}']=$posTaxMode?'':' ('._nCut($currTax,2).'%)';
		_rsubstr($patt,'{sumTDVl}','',$discMode);
		_rsubstr($patt,'{taxTDVl}','',$posTaxMode);
		_rsubstr($patt,'{discTDVl}','',$discMode);
		$totDiscType=_getSysAttr($obj,'odsctp');
		if($totDisc){
			if($totDiscType=='%'){
				$resTotal=_nCut($total*(1-$totDisc*0.01),2);
				$totDiscVal=$total-$resTotal;
				$total=$resTotal;
			}else{
				$totDiscVal=$totDisc;
				$total-=$totDisc;
			}
			$repl[$discMode?'{discTot}':'{discTot1}']=_formatVal($totDiscVal,'nm').($discMode?($totDiscType=='%'?' ('.$totDisc.'%)':''):'');
			$repl[$discMode?'{discTot1}':'{discTot}']='&nbsp';
			$repl['{dsc_rate}']=$discMode?'':($totDiscType=='%'?' ('.$totDisc.'%)':'');
			$repl['{dsc_stl}']=$discMode?'':'border-right:none;';
		}
		_rsubstr($patt,'{totSumTDVl}','',$totDisc);
		_rsubstr($patt,'{totDiscTDVl}','',$totDisc);
		$col=$codeMode?6:5;
		$coldsc=($discMode?6:4)+($codeMode?1:0);
		if($posTaxMode){
			++$coldsc;
			++$col;
		}
		if($discMode){
			$col+=2;
		}
		$repl['{coldsc}']=$coldsc;
		$repl['{col}']=$col;
		$repl['{total}']=_formatVal($total,'nm');
		$repl['{tot_tax}']=_formatVal($totTax?$totTax:$total*$currTax/(100+$currTax),'nm');
		_rsubstr($patt,'{totTaxTDVl}','',$totTaxMode);
		$repl['{addInfo}']=$addInfo?$addInfo:'';
		print strtr($patt,$repl);
	}
}
function _sentMailPatt($sender,$to,$file,$repl){
	if(!is_file($file)){return;}
	$cont=file_get_contents($file);
	$cont=strtr($cont,$repl);
	$cont=explode('::',$cont);
	$headers='';
	foreach($cont as $itm){
		$prop=explode(':',$itm);
		if(!$prop[0]){continue;}
		$head=strtolower($prop[0]);
		switch($head){
			case 'subject':
				$subject=substr($itm,8);
				break;
			case 'content':
				$message=substr($itm,8);
				break;
			case 'from':
				break;
			case 'to':
				break;
			default:
				$headers.="\r\n".$prop[0].': '.str_replace("\r\n",'',$prop[1]);
		}
	}
	$headers='From: '.$sender.$headers.chr(13).chr(10).'X-Mailer: PHP/'.phpversion();
	ini_set('sendmail_from',$sender);
	$mod=mail($to,$subject,$message,$headers);
	return $mod;
}
?>